program decodeblowfish;

{$mode objfpc}{$H+}

uses
  Classes, SysUtils, blowfish;

var
  B : TBlowfishDecryptStream;
  Fin,Fout : TFileStream;
  Buf : Array[1..1024] of Byte;
  K : TBlowFishKey;
  S,FN : String;
  KLen,Count : Integer;

begin
  If (ParamCount=0) then
    begin
    Writeln('usage: decodeblowfish filename passphrase');
    halt(1);
    end;
  FN:=ParamStr(1);
  S:=ParamStr(2);
  KLen:=Length(S);
  If (Length(S)>56) then
    KLen:=56;
  Move(S[1],K,56);
  FIn:=TFileStream.Create(FN,fmOpenRead);
  B:=TBlowFishDecryptStream.Create(K,KLen,FIn);
  try
    FN:=ChangeFileExt(FN,'');
    FOut:=TFileStream.Create(FN,fmCreate);
    try
      Repeat
        Count:=B.Read(Buf,SizeOf(Buf));
        If Count>0 then
          FOut.WriteBuffer(Buf,Count);
      Until (Count<SizeOf(Buf));
    Finally
      Fout.Free;
    end;
  finally
    B.Free;
  end;
end.

